## massxpert 2.0.3

=== CMakeLists.txt ===
#############################################################
# Software configuration
PROJECT (massxpert)
SET (VERSION "2.0.3")

IF (APPLE)
  # If Mac OS X, then capitalize the program name.
  set (PROGNAME massXpert)
ELSE (NOT APPLE)
  set (PROGNAME massxpert)
ENDIF (APPLE)

# Required to install and reference the translation files and to give
# to the executable (in Mac OS X) the proper filename.
set (TARGET ${PROGNAME})

#############################################################
# CMake configuration
CMAKE_MINIMUM_REQUIRED (VERSION 2.6.0)

SET (CMAKE_COLOR_MAKEFILE ON)
SET (CMAKE_VERBOSE_MAKEFILE ON)

#############################################################
# Enable warnings and treat them as errors
SET (PEDANTIC TRUE CACHE BOOL "Should we compile with -Wall -Werror.")

IF (PEDANTIC)
  ADD_DEFINITIONS (-Wall -Werror)
ENDIF (PEDANTIC)

#############################################################
#############################################################
# Installation directories depending on the platform.

IF (WIN32)
  # ${CMAKE_INSTALL_PREFIX} == "C:/Program Files/massxpert" The
  # CMAKE_INSTALL_PREFIX value can be changed by running
  #
  #'cmake -d CMAKE_INSTALL_PREFIX=C:/Program Files/massxpert'
  #
  #, for example.
  SET (MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX})
  SET (MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data)
  SET (MASSXPERT_PLUGIN_DIR ${CMAKE_INSTALL_PREFIX}/plugins)
  SET (MASSXPERT_LOCALE_DIR ${CMAKE_INSTALL_PREFIX}/locales)
  SET (MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc)
  SET (MASSXPERT_USERMAN_DIR ${MASSXPERT_DOC_DIR}/usermanual)
ENDIF (WIN32)

IF (UNIX AND NOT APPLE)
  SET (MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/massxpert)
  SET (MASSXPERT_PLUGIN_DIR ${CMAKE_INSTALL_PREFIX}/lib/massxpert/plugins)
  SET (MASSXPERT_LOCALE_DIR ${CMAKE_INSTALL_PREFIX}/share/massxpert/locales)
  SET (MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/massxpert)
  SET (MASSXPERT_USERMAN_DIR ${MASSXPERT_DOC_DIR}/usermanual)
ENDIF (UNIX AND NOT APPLE)

IF (APPLE)
  SET (BUNDLE_DIR ${CMAKE_CURRENT_BINARY_DIR}/gui/massXpert.app)
  SET (MASSXPERT_BIN_DIR ${BUNDLE_DIR}/Contents/MacOS)
  SET (MASSXPERT_DATA_DIR ${BUNDLE_DIR}/Contents/Resources/data)
  SET (MASSXPERT_PLUGIN_DIR ${BUNDLE_DIR}/Contents/Plugins)
  SET (MASSXPERT_LOCALE_DIR ${BUNDLE_DIR}/Contents/Locales)
  SET (MASSXPERT_DOC_DIR ${BUNDLE_DIR}/Contents/Doc)
  SET (MASSXPERT_USERMAN_DIR ${MASSXPERT_DOC_DIR}/UserManual)
ENDIF (APPLE)



#############################################################
#############################################################
# There are two functional subtrees in the source:
#
# 1. The source code generating the massxpert binary, which is
# architecture-dependent;
#
# 2. The chemical data and the documentation (user manual) which are
# architecture independent.
#
# Note that if BUILD_ALL = 1 then all of the BUILD_PROGRAM, BUILD_DATA or
# BUILD_USERMANUAL are defined to 1 and everything is built.

IF (${BUILD_ALL})
  SET (BUILD_PROGRAM 1)
  SET (BUILD_DATA 1)
  SET (BUILD_USERMANUAL 1)
ENDIF (${BUILD_ALL})

IF (${BUILD_RESET})
  SET (BUILD_PROGRAM 0)
  SET (BUILD_DATA 0)
  SET (BUILD_USERMANUAL 0)
ENDIF (${BUILD_RESET})


#############################################################
######################
# BUILD OF THE PROGRAM

IF (${BUILD_PROGRAM})
  
  MESSAGE (STATUS "BUILD_PROGRAM:" ${BUILD_PROGRAM})


  ################
  # Search for Qt4
  SET (QT_USE_QTXML TRUE)
  SET (QT_USE_QTSVG TRUE)

  SET (QT_MIN_VERSION "4.4.0")
  FIND_PACKAGE (Qt4 REQUIRED)
  MESSAGE (STATUS "QTVERSION:" ${QTVERSION})

  INCLUDE (${QT_USE_FILE})

  # Use all the configured paths to create the config.h file.
  CONFIGURE_FILE (${CMAKE_SOURCE_DIR}/CMakeTemplates/config.h.in 
    ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

  ###############
  # install stuff

  # The license file
  INSTALL (FILES COPYING
    DESTINATION ${MASSXPERT_DOC_DIR})

  # The desktop file
  IF (UNIX AND NOT APPLE)
    INSTALL (FILES massxpert.desktop
      DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
  ENDIF (UNIX AND NOT APPLE)

  # The manual page
  IF (UNIX AND NOT APPLE)
    INSTALL (FILES massxpert.1
      DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
  ENDIF (UNIX AND NOT APPLE)

  ###############
  # Plugins should not have a soname, so override the CMake default, which gives them one
  # create a shared C++ library but with no soname in the lib file:
  SET(CMAKE_CXX_CREATE_SHARED_MODULE
    "<CMAKE_CXX_COMPILER> <CMAKE_SHARED_LIBRARY_CXX_FLAGS> <LANGUAGE_COMPILE_FLAGS> <LINK_FLAGS> <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS>  -o <TARGET> <OBJECTS> <LINK_LIBRARIES>")
  # Compare the line above with
  # /usr/share/cmake-2.6/Modules/CMakeCXXInformation.cmake

  #################
  # process subdirs
  SUBDIRS (lib gui plugins-src)


ENDIF (${BUILD_PROGRAM})


#############################################################
###################
# BUILD OF THE DATA

IF (${BUILD_DATA})
  
  MESSAGE (STATUS "BUILD_DATA:" ${BUILD_DATA})
  
  ###############
  # install stuff
  
  # The license file
  INSTALL (FILES COPYING
    DESTINATION ${MASSXPERT_DOC_DIR})
  
  # The manual pages (data)
  IF (UNIX AND NOT APPLE)
    INSTALL (FILES massxpert-data.7
      DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man7)
  ENDIF (UNIX AND NOT APPLE)
  
  #################
  # process subdirs
  SUBDIRS (data)
  
ENDIF (${BUILD_DATA})


#############################################################
##########################
# BUILD OF THE USER MANUAL

IF (${BUILD_USERMANUAL})
  
  MESSAGE (STATUS "BUILD_USERMANUAL:" ${BUILD_USERMANUAL})
  
  # Below : no more in use since started using UseLATEX.cmake
  # Use the configured VERSION to create the 
  # usermanual/massxpert-version.tex file
  #
  #CONFIGURE_FILE (${CMAKE_SOURCE_DIR}/CMakeTemplates/massxpert-version.tex.in
  #  ${CMAKE_SOURCE_DIR}/usermanual/massxpert-version.tex @ONLY)
  
  
  ###############
  # install stuff
  
  # The license file
  INSTALL (FILES COPYING
    DESTINATION ${MASSXPERT_DOC_DIR})
  
  # The manual pages (user manual)
  IF (UNIX AND NOT APPLE)
    INSTALL (FILES massxpert-doc.7
      DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man7)
  ENDIF (UNIX AND NOT APPLE)
  
  
  #################
  # process subdirs
  SUBDIRS (usermanual)

ENDIF (${BUILD_USERMANUAL})


#############################################################
# summary
MESSAGE ("")
MESSAGE ("~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~")
MESSAGE (STATUS "TARGET: " ${TARGET}  --  "VERSION: " ${VERSION})
MESSAGE (STATUS "CMAKE_INSTALL_PREFIX: " ${CMAKE_INSTALL_PREFIX})
MESSAGE (STATUS "MASSXPERT_BIN_DIR: " ${MASSXPERT_BIN_DIR})
MESSAGE (STATUS "MASSXPERT_DATA_DIR: " ${MASSXPERT_DATA_DIR})
MESSAGE (STATUS "MASSXPERT_PLUGIN_DIR: " ${MASSXPERT_PLUGIN_DIR})
MESSAGE (STATUS "MASSXPERT_LOCALE_DIR: " ${MASSXPERT_LOCALE_DIR})
MESSAGE (STATUS "MASSXPERT_DOC_DIR: " ${MASSXPERT_DOC_DIR})
MESSAGE (STATUS "MASSXPERT_USERMAN_DIR: " ${MASSXPERT_USERMAN_DIR})
MESSAGE ("~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~")
MESSAGE ("")

=== data/CMakeLists.txt ===
INSTALL (DIRECTORY pol-chem-defs pol-seqs 
  DESTINATION ${MASSXPERT_DATA_DIR})

INSTALL (FILES chem_pad.conf protein-1-to-3.dic protein-3-to-1.dic
  DESTINATION ${MASSXPERT_DATA_DIR})

=== gui/CMakeLists.txt ===
########################################################
# Files

# Obtain the list with 
# for i in $(ls *.cpp -1 | grep -v ^moc.* | grep -v ^qrc.*) ; do echo "  $i";done
SET (massxpert_SRCS
  aboutDlg.cpp
  application.cpp
  atomDefDlg.cpp
  calculatorChemPadDlg.cpp
  calculatorRecorderDlg.cpp
  calculatorWnd.cpp
  chemPadButton.cpp
  cleavageDlg.cpp
  cleaveOligomerTreeView.cpp
  cleaveOligomerTreeViewItem.cpp
  cleaveOligomerTreeViewMimeData.cpp
  cleaveOligomerTreeViewModel.cpp
  cleaveOligomerTreeViewSortProxyModel.cpp
  cleaveSpecDefDlg.cpp
  compositionsDlg.cpp
  compositionTreeView.cpp
  compositionTreeViewItem.cpp
  compositionTreeViewModel.cpp
  compositionTreeViewSortProxyModel.cpp
  configurationSettingsDlg.cpp
  crossLinkerDefDlg.cpp
  decimalPlacesOptionsDlg.cpp
  fragmentationDlg.cpp
  fragmentOligomerTreeView.cpp
  fragmentOligomerTreeViewItem.cpp
  fragmentOligomerTreeViewMimeData.cpp
  fragmentOligomerTreeViewModel.cpp
  fragmentOligomerTreeViewSortProxyModel.cpp
  fragSpecDefDlg.cpp
  isotopicPatternCalculationDlg.cpp
  main.cpp
  mainWindow.cpp
  massSearchDlg.cpp
  massSearchOligomerTreeView.cpp
  massSearchOligomerTreeViewItem.cpp
  massSearchOligomerTreeViewMimeData.cpp 
  massSearchOligomerTreeViewModel.cpp
  massSearchOligomerTreeViewSortProxyModel.cpp
  modifDefDlg.cpp
  monomerCodeEvaluator.cpp
  monomerCrossLinkDlg.cpp
  monomerDefDlg.cpp
  monomerModificationDlg.cpp
  mzCalculationDlg.cpp
  mzCalculationTreeView.cpp
  mzCalculationTreeViewItem.cpp
  mzCalculationTreeViewModel.cpp
  mzCalculationTreeViewSortProxyModel.cpp
  mzLabInputOligomerTreeView.cpp
  mzLabInputOligomerTreeViewDlg.cpp
  mzLabInputOligomerTreeViewItem.cpp
  mzLabInputOligomerTreeViewModel.cpp
  mzLabInputOligomerTreeViewSortProxyModel.cpp
  mzLabOutputOligomerTreeView.cpp
  mzLabOutputOligomerTreeViewDlg.cpp
  mzLabOutputOligomerTreeViewItem.cpp
  mzLabOutputOligomerTreeViewModel.cpp
  mzLabOutputOligomerTreeViewSortProxyModel.cpp
  mzLabWnd.cpp
  pkaPhPiDlg.cpp
  polChemDefWnd.cpp
  polymerModificationDlg.cpp
  regionSelection.cpp
  sequenceEditorFindDlg.cpp
  sequenceEditorGraphicsView.cpp
  sequenceEditorGraphicsViewKeyboardHandling.cpp
  sequenceEditorGraphicsViewKeySequenceHandling.cpp
  sequenceEditorWnd.cpp
  sequencePurificationDlg.cpp
  sequenceSelection.cpp
)

# Obtain the list with 
# for i in $(grep -l Q_OBJECT *.hpp) ; do echo "  $i"; done
SET (massxpert_MOC_HDRS
  aboutDlg.hpp
  application.hpp
  atomDefDlg.hpp
  calculatorChemPadDlg.hpp
  calculatorRecorderDlg.hpp
  calculatorWnd.hpp
  chemPadButton.hpp
  cleavageDlg.hpp
  cleaveOligomerTreeView.hpp
  cleaveOligomerTreeViewMimeData.hpp
  cleaveOligomerTreeViewModel.hpp
  cleaveSpecDefDlg.hpp
  compositionsDlg.hpp
  compositionTreeView.hpp
  compositionTreeViewModel.hpp
  configurationSettingsDlg.hpp
  crossLinkerDefDlg.hpp
  decimalPlacesOptionsDlg.hpp
  fragmentationDlg.hpp
  fragmentOligomerTreeView.hpp
  fragmentOligomerTreeViewMimeData.hpp
  fragmentOligomerTreeViewModel.hpp
  fragSpecDefDlg.hpp
  isotopicPatternCalculationDlg.hpp
  mainWindow.hpp
  massSearchDlg.hpp
  massSearchOligomerTreeView.hpp
  massSearchOligomerTreeViewMimeData.hpp
  massSearchOligomerTreeViewModel.hpp
  modifDefDlg.hpp
  monomerCodeEvaluator.hpp
  monomerCrossLinkDlg.hpp
  monomerDefDlg.hpp
  monomerModificationDlg.hpp
  mzCalculationDlg.hpp
  mzCalculationTreeView.hpp
  mzCalculationTreeViewModel.hpp
  mzLabInputOligomerTreeView.hpp
  mzLabInputOligomerTreeViewDlg.hpp
  mzLabInputOligomerTreeViewModel.hpp
  mzLabOutputOligomerTreeView.hpp
  mzLabOutputOligomerTreeViewDlg.hpp
  mzLabOutputOligomerTreeViewModel.hpp
  mzLabWnd.hpp
  pkaPhPiDlg.hpp
  polChemDefWnd.hpp
  polymerModificationDlg.hpp
  sequenceEditorFindDlg.hpp
  sequenceEditorGraphicsView.hpp
  sequenceEditorWnd.hpp
  sequencePurificationDlg.hpp
  )

# Obtain the list with 
# for i in $(ls ui/*.ui) ; do echo "  $i"; done
SET (massxpert_UIS
  ui/aboutDlg.ui
  ui/atomDefDlg.ui
  ui/calculatorChemPadDlg.ui
  ui/calculatorRecorderDlg.ui
  ui/calculatorWnd.ui
  ui/cleavageDlg.ui
  ui/cleaveSpecDefDlg.ui
  ui/compositionsDlg.ui
  ui/configurationSettingsDlg.ui
  ui/crossLinkerDefDlg.ui
  ui/fragmentationDlg.ui
  ui/fragSpecDefDlg.ui
  ui/decimalPlacesOptionsDlg.ui
  ui/isotopicPatternCalculationDlg.ui
  ui/massSearchDlg.ui
  ui/modifDefDlg.ui
  ui/monomerCrossLinkDlg.ui
  ui/monomerDefDlg.ui
  ui/monomerModificationDlg.ui
  ui/mzCalculationDlg.ui
  ui/mzLabInputOligomerTreeViewDlg.ui
  ui/mzLabOutputOligomerTreeViewDlg.ui
  ui/mzLabWnd.ui
  ui/pkaPhPiDlg.ui
  ui/polChemDefWnd.ui
  ui/polymerModificationDlg.ui
  ui/sequenceEditorFindDlg.ui
  ui/sequenceEditorWnd.ui
  ui/sequencePurificationDlg.ui
)


#############################################################
# application icon
IF (WIN32 AND NOT MSVC)
  # Icon for windows
  # Note: can't include .rc directly to source files
  # as it's ignored when used MinGW
  IF (NOT WINDRES)
    FIND_PROGRAM (WINDRES windres)
    IF (NOT WINDRES)
      MESSAGE (FATAL_ERROR "windres not found - aborting")
    ENDIF (NOT WINDRES)
  ENDIF (NOT WINDRES)
  
  IF (MINGW)
    # resource compilation for MinGW
    ADD_CUSTOM_COMMAND (OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/icon.obj
      COMMAND ${WINDRES} 
      -I${CMAKE_CURRENT_SOURCE_DIR} -i${CMAKE_CURRENT_SOURCE_DIR}/massxpert.rc
      -o ${CMAKE_CURRENT_BINARY_DIR}/icon.obj
      )
    SET (massxpert_SRCS ${massxpert_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/icon.obj)
  ELSE (MINGW)
    SET (massxpert_SRCS ${massxpert_SRCS} 
      ${CMAKE_CURRENT_SOURCE_DIR}/massxpert.rc)
  ENDIF (MINGW)
  
ENDIF (WIN32 AND NOT MSVC)


########################################################
# Build

QT4_WRAP_CPP (massxpert_MOC_SRCS  ${massxpert_MOC_HDRS})

QT4_WRAP_UI (massxpert_UIS_H ${massxpert_UIS})

QT4_ADD_RESOURCES (massxpertQRC_CPP application.qrc)

IF (APPLE)

ADD_EXECUTABLE (${PROGNAME}  MACOSX_BUNDLE 
  ${massxpert_SRCS} 
  ${massxpert_MOC_SRCS}
  ${massxpert_UIS_H} 
  ${massxpertQRC_CPP})

# Apple bundle configuration

  SET (MACOSX_BUNDLE_INFO_STRING "massXpert - version ${VERSION}")
  SET (MACOSX_BUNDLE_BUNDLE_VERSION ${VERSION})
  # Change following line to point to actual icns file in bundle.
  SET (MACOSX_BUNDLE_ICON_FILE "massXpert.icns")
  # means bundle is set to be org.massxpert
  SET (MACOSX_BUNDLE_GUI_IDENTIFIER "org.massxpert")
  SET (MACOSX_BUNDLE_BUNDLE_NAME "massXpert")

  EXEC_PROGRAM ("mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/massXpert.app/Contents/Resources")
  
EXEC_PROGRAM ("cp ${CMAKE_CURRENT_SOURCE_DIR}/images/massXpert.icns ${CMAKE_CURRENT_BINARY_DIR}/massXpert.app/Contents/Resources")
  
# We want to build universal binaries 
SET (CMAKE_OSX_ARCHITECTURES "ppc;i386" 
  CACHE STRING "Build architectures for OSX" FORCE) 

# That can be deployed on older system 
# (Qt 4.4.0 is available starting at 10.3.9) 
SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.3" 
  CACHE STRING "Flags used by the compiler during all build types." FORCE)

SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden" 
  CACHE STRING "Flags used by the compiler during all build types." FORCE)

SET (CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.4u.sdk" 
  CACHE STRING "MacOSX10.4u.sdk." FORCE)

SET_SOURCE_FILES_PROPERTIES (application.qrc ${TARGET}_fr.qm 
  PROPERTIES MACOSX_BUNDLE_LOCATION Resources)

ELSE (APPLE)

ADD_EXECUTABLE (${PROGNAME}
  ${massxpert_SRCS} 
  ${massxpert_MOC_SRCS}
  ${massxpert_UIS_H} 
  ${massxpertQRC_CPP})

ENDIF (APPLE)

INCLUDE_DIRECTORIES (
  ${QT_INCLUDE_DIR}
  ${QT_QTXML_INCLUDE_DIR}
  ${QT_QTSVG_INCLUDE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR} 
  ${CMAKE_BINARY_DIR} # for the config.h file generated from config.h.in
  ../lib
  )


# Make sure all the symbols from libmasslib.a are in the executable binary!
IF (APPLE)
  SET(MASSLIB -Wl,-all_load ${massxpert_BINARY_DIR}/lib/libmasslib.a -Wl,-noall_load)
ELSE (APPLE)
  SET(MASSLIB -Wl,-whole-archive ${massxpert_BINARY_DIR}/lib/libmasslib.a -Wl,-no-whole-archive)
ENDIF (APPLE)

  
TARGET_LINK_LIBRARIES (${PROGNAME}
  ${QT_LIBRARIES}
  ${QT_QTXML_LIBRARIES}
  ${QT_QTSVG_LIBRARIES}
  ${MASSLIB}
  )

SET (massxpert_TRANSLATIONS massxpert_fr.qm)

INSTALL (FILES ${massxpert_TRANSLATIONS} 
  DESTINATION ${MASSXPERT_LOCALE_DIR})

IF (APPLE)
  # Copy the massXpert.icns icon file in the bundle
  INSTALL (FILES images/massXpert.icns
    DESTINATION ${BUNDLE_DIR}/Contents/Resources)
  
  # Copy the Info.plist file in the bundle
  #INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/massXpert.app/Contents/Info.plist
  #  DESTINATION ${BUNDLE_DIR}/Contents)

ENDIF (APPLE)

IF (NOT APPLE)

  # When building a Mac bundle, we do not install the target
  # because the bundle is being fabricated already.

  INSTALL (TARGETS ${PROGNAME} 
    RUNTIME DESTINATION ${MASSXPERT_BIN_DIR})

ENDIF (NOT APPLE)

=== lib/CMakeLists.txt ===
########################################################
# Files

# Obtain the list with 
# for i in $(ls *.cpp -1 | grep -v ^moc.* | grep -v ^qrc.*) ; do echo "  $i";done
SET (masslib_SRCS
  atomCount.cpp
  atom.cpp
  calcOptions.cpp
  chemEntVignette.cpp
  chemEntVignetteRenderer.cpp
  chemicalGroup.cpp
  chemicalGroupRule.cpp
  cleaveMotif.cpp
  cleaveOligomer.cpp
  cleaveOptions.cpp
  cleaver.cpp
  cleaveRule.cpp
  cleaveSpec.cpp
  configSettings.cpp
  coordinates.cpp
  crossLink.cpp
  crossLinker.cpp
  crossLinkerSpec.cpp
  crossLinkList.cpp
  formula.cpp
  fragmenter.cpp
  fragmentOligomer.cpp
  fragOptions.cpp
  fragRule.cpp
  fragSpec.cpp
  globals.cpp
  ionizable.cpp
  ionizeRule.cpp
  isotope.cpp
  isotopicPeak.cpp
  massList.cpp
  modif.cpp
  modifSpec.cpp
  monomer.cpp
  monomerSpec.cpp
  oligomer.cpp
  oligomerList.cpp
  oligomerPair.cpp
  pkaPhPi.cpp
  pkaPhPiDataParser.cpp
  polChemDefCatParser.cpp
  polChemDef.cpp
  polChemDefEntity.cpp
  polChemDefSpec.cpp
  polymer.cpp
  ponderable.cpp
  prop.cpp
  propListHolder.cpp
  sequence.cpp
  userSpec.cpp
  )

# Obtain the list with 
# for i in $(grep -l Q_OBJECT *.hpp) ; do echo "  $i"; done
SET (masslib_MOC_HDRS
  chemEntVignette.hpp
  chemEntVignetteRenderer.hpp
  crossLinkList.hpp
  oligomerList.hpp
  polymer.hpp
  )


########################################################
# Build

QT4_WRAP_CPP (masslib_MOC_SRCS  ${masslib_MOC_HDRS})

IF( APPLE )

ENDIF (APPLE)

ADD_LIBRARY (masslib STATIC 
  ${masslib_SRCS} ${masslib_MOC_SRCS}
  )


INCLUDE_DIRECTORIES (
  ${QT_INCLUDE_DIR}
  ${QT_QTXML_INCLUDE_DIR}
  ${QT_QTSVG_INCLUDE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_BINARY_DIR} # for the config.h file generated from config.h.in
  )

TARGET_LINK_LIBRARIES (masslib
  ${QT_LIBRARIES}
  ${QT_QTXML_LIBRARIES}
  ${QT_QTSVG_LIBRARIES}
  )

=== usermanual/CMakeLists.txt ===
#############################################################
# There are warning issued during the compilation of almost
# any LaTeX source, but we want the compilation not to stop...
# Because the build process has -Werror set globally we want to
# disable it here specifically.
IF (PEDANTIC)
  REMOVE_DEFINITIONS (-Werror)
ENDIF (PEDANTIC)

IF (UNIX AND NOT APPLE)

  INCLUDE (UseLATEX.cmake)
  
  SET (texInputFiles massxpert-macros.tex massxpert-version.tex 
    titlepage.tex front-matter.tex toc-lof-lot.tex 
    preface.tex installation.tex basics-polchem.tex basics-massspec.tex
    generalities.tex xpertdef.tex xpertcalc.tex xpertedit.tex
    xpertminer.tex data-customization.tex appendices.tex 
    protein-1-letter.xml.tex leu-enkephalin.mxp.tex pka_ph_pi.xml.tex 
    GNU-GPL-3.0.tex index.tex)
  
  ADD_LATEX_DOCUMENT (massxpert.tex
    DEFAULT_PDF
    INPUTS ${texInputFiles}
    CONFIGURE massxpert-version.tex
    DEPENDS massxpert-style.sty 
    IMAGE_DIRS figures
    USE_INDEX)
  
ENDIF (UNIX AND NOT APPLE)

# With Apple Mac we do not deliver the user manual in the source
# package but in the disk image (dmg file).
IF (NOT APPLE)
  INSTALL (FILES ${CMAKE_BINARY_DIR}/usermanual/massxpert.pdf
    DESTINATION ${MASSXPERT_USERMAN_DIR})
ENDIF(NOT APPLE)

## massxpert 2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #############################################################
 # Software configuration
 PROJECT (massxpert)
-SET (VERSION "2.0.3")
+SET (VERSION "2.1.1")
 
 IF (APPLE)
   # If Mac OS X, then capitalize the program name.
@@ -45,13 +45,19 @@
   SET (MASSXPERT_PLUGIN_DIR ${CMAKE_INSTALL_PREFIX}/plugins)
   SET (MASSXPERT_LOCALE_DIR ${CMAKE_INSTALL_PREFIX}/locales)
   SET (MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc)
-  SET (MASSXPERT_USERMAN_DIR ${MASSXPERT_DOC_DIR}/usermanual)
 ENDIF (WIN32)
 
 IF (UNIX AND NOT APPLE)
   SET (MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
   SET (MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/massxpert)
-  SET (MASSXPERT_PLUGIN_DIR ${CMAKE_INSTALL_PREFIX}/lib/massxpert/plugins)
+
+  # Plugin-specific stuff, some distros set CMAKE_INSTALL_LIBDIR to
+  # /usr/lib64 (Fedora64, for example)
+  IF (NOT CMAKE_INSTALL_LIBDIR)
+    SET (CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib)
+  ENDIF (NOT CMAKE_INSTALL_LIBDIR)
+  SET (MASSXPERT_PLUGIN_DIR ${CMAKE_INSTALL_LIBDIR}/massxpert/plugins)
+
   SET (MASSXPERT_LOCALE_DIR ${CMAKE_INSTALL_PREFIX}/share/massxpert/locales)
   SET (MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/massxpert)
   SET (MASSXPERT_USERMAN_DIR ${MASSXPERT_DOC_DIR}/usermanual)
@@ -64,7 +70,6 @@
   SET (MASSXPERT_PLUGIN_DIR ${BUNDLE_DIR}/Contents/Plugins)
   SET (MASSXPERT_LOCALE_DIR ${BUNDLE_DIR}/Contents/Locales)
   SET (MASSXPERT_DOC_DIR ${BUNDLE_DIR}/Contents/Doc)
-  SET (MASSXPERT_USERMAN_DIR ${MASSXPERT_DOC_DIR}/UserManual)
 ENDIF (APPLE)
 
 
@@ -82,17 +87,23 @@
 # Note that if BUILD_ALL = 1 then all of the BUILD_PROGRAM, BUILD_DATA or
 # BUILD_USERMANUAL are defined to 1 and everything is built.
 
-IF (${BUILD_ALL})
+IF (BUILD_ALL)
   SET (BUILD_PROGRAM 1)
   SET (BUILD_DATA 1)
   SET (BUILD_USERMANUAL 1)
-ENDIF (${BUILD_ALL})
-
-IF (${BUILD_RESET})
+ENDIF (BUILD_ALL)
+
+IF (BUILD_RESET)
   SET (BUILD_PROGRAM 0)
   SET (BUILD_DATA 0)
   SET (BUILD_USERMANUAL 0)
-ENDIF (${BUILD_RESET})
+ENDIF (BUILD_RESET)
+
+IF (NOT BUILD_PROGRAM AND NOT BUILD_DATA AND NOT BUILD_USERMANUAL)
+  SET (BUILD_PROGRAM 1)
+  SET (BUILD_DATA 1)
+  SET (BUILD_USERMANUAL 0)
+ENDIF (NOT BUILD_PROGRAM AND NOT BUILD_DATA AND NOT BUILD_USERMANUAL)
 
 
 #############################################################
@@ -100,9 +111,6 @@
 # BUILD OF THE PROGRAM
 
 IF (${BUILD_PROGRAM})
-  
-  MESSAGE (STATUS "BUILD_PROGRAM:" ${BUILD_PROGRAM})
-
 
   ################
   # Search for Qt4
@@ -160,8 +168,6 @@
 
 IF (${BUILD_DATA})
   
-  MESSAGE (STATUS "BUILD_DATA:" ${BUILD_DATA})
-  
   ###############
   # install stuff
   
@@ -187,8 +193,6 @@
 # BUILD OF THE USER MANUAL
 
 IF (${BUILD_USERMANUAL})
-  
-  MESSAGE (STATUS "BUILD_USERMANUAL:" ${BUILD_USERMANUAL})
   
   # Below : no more in use since started using UseLATEX.cmake
   # Use the configured VERSION to create the 
@@ -223,6 +227,10 @@
 # summary
 MESSAGE ("")
 MESSAGE ("~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~")
+MESSAGE (STATUS "BUILD_PROGRAM:" ${BUILD_PROGRAM})
+MESSAGE (STATUS "BUILD_DATA:" ${BUILD_DATA})
+MESSAGE (STATUS "BUILD_USERMANUAL:" ${BUILD_USERMANUAL})
+MESSAGE ("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
 MESSAGE (STATUS "TARGET: " ${TARGET}  --  "VERSION: " ${VERSION})
 MESSAGE (STATUS "CMAKE_INSTALL_PREFIX: " ${CMAKE_INSTALL_PREFIX})
 MESSAGE (STATUS "MASSXPERT_BIN_DIR: " ${MASSXPERT_BIN_DIR})

=== data/CMakeLists.txt ===
INSTALL (DIRECTORY pol-chem-defs pol-seqs 
  DESTINATION ${MASSXPERT_DATA_DIR})

INSTALL (FILES chem_pad.conf codon-to-protein-1.dic 
  codon-to-protein-3.dic protein-1-to-3.dic protein-3-to-1.dic
  DESTINATION ${MASSXPERT_DATA_DIR})

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,7 @@
   application.cpp
   atomDefDlg.cpp
   calculatorChemPadDlg.cpp
+  calculatorChemPadGroupBox.cpp
   calculatorRecorderDlg.cpp
   calculatorWnd.cpp
   chemPadButton.cpp
@@ -83,6 +84,7 @@
   application.hpp
   atomDefDlg.hpp
   calculatorChemPadDlg.hpp
+  calculatorChemPadGroupBox.hpp
   calculatorRecorderDlg.hpp
   calculatorWnd.hpp
   chemPadButton.hpp

=== plugins-src/CMakeLists.txt ===
#############################################################
# process subdirs
SUBDIRS (massListSorterPlugin seqToolsPlugin numeralsLocaleConverterPlugin)
#SUBDIRS (seqToolsPlugin)

## massxpert 2.3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #############################################################
 # Software configuration
 PROJECT (massxpert)
-SET (VERSION "2.1.1")
+SET (VERSION "2.3.6")
 
 IF (APPLE)
   # If Mac OS X, then capitalize the program name.
@@ -22,12 +22,22 @@
 SET (CMAKE_VERBOSE_MAKEFILE ON)
 
 #############################################################
-# Enable warnings and treat them as errors
-SET (PEDANTIC TRUE CACHE BOOL "Should we compile with -Wall -Werror.")
-
-IF (PEDANTIC)
-  ADD_DEFINITIONS (-Wall -Werror)
-ENDIF (PEDANTIC)
+# Enable warnings and treat them as errors, on GNU/Linux only
+IF (UNIX)
+  SET (PEDANTIC TRUE CACHE BOOL "Should we compile with -Wall -Werror.")
+  
+  IF (PEDANTIC)
+    ADD_DEFINITIONS (-Wall -Werror)
+  ENDIF (PEDANTIC)
+ENDIF (UNIX)
+
+IF (WIN32)
+  SET (PEDANTIC TRUE CACHE BOOL "Should we compile with -Wall.")
+  
+  IF (PEDANTIC)
+    ADD_DEFINITIONS (-Wall)
+  ENDIF (PEDANTIC)
+ENDIF (WIN32)
 
 #############################################################
 #############################################################
@@ -156,7 +166,7 @@
 
   #################
   # process subdirs
-  SUBDIRS (lib gui plugins-src)
+  SUBDIRS (lib gui plugins-src i18n)
 
 
 ENDIF (${BUILD_PROGRAM})

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -38,6 +38,7 @@
   modif.cpp
   modifSpec.cpp
   monomer.cpp
+  monomerDictionary.cpp
   monomerSpec.cpp
   oligomer.cpp
   oligomerList.cpp

=== debian/changelog ===
massxpert (2.3.6-1squeeze1) testing-proposed-updates; urgency=low

  * Fix (Closes: #611142)for the crash due to clicking on the left of the
    first vignette in the sequence editor.

 -- Filippo Rusconi <rusconi-debian@laposte.net>  Sun, 30 Jan 2011 20:35:32 +0100

massxpert (2.3.6-1) unstable; urgency=low

  * Upstream release:

    - Add a warning when the user is trying a polymer cleavage on a region
    not encompassing all the cross-linked monomers;

    - Fix a linker flag for the MacOSX PPC build;
    
    - Fix a GUI bug in the sequence editor window
    (gui/monomerCodeEvaluator.cpp).
  
 -- Filippo Rusconi <rusconi-debian@laposte.net>  Mon, 10 May 2010 20:16:34 +0200

massxpert (2.3.5-1) unstable; urgency=low

  * Upstream release:
    
    - Add feature to compute the mass differences between any two monomers
    in the polymer chemistry definition;
    
    - Update the user manual to document the new feature.

 -- Filippo Rusconi <rusconi-debian@laposte.net>  Thu, 29 Apr 2010 15:13:50 +0200

massxpert (2.3.0-1) unstable; urgency=low

  * Upstream release: 
    
    - Add feature to allow cleaving polymer sequences only in the
    currently selected region of the sequence;
    
    - Improvements in the GUI of the cleavage dialog window;
    
    - Fix one bug in the constructor of the CalcOptions object, which
    failed to correctly initialize the CoordinateList member data;
    
    - Update the documentation (user manual) to describe the new cleavage
    feature.

 -- Filippo Rusconi <rusconi-debian@laposte.net>  Tue, 27 Apr 2010 14:20:25 +0200

massxpert (2.2.0-1) unstable; urgency=low

  * Upstream release:
  
    - Fix bug with polymer sequence not saving a modified name in the
    sequence editor window;
  
    - Implemented a protein sequence importer for PDB cristallographic
    data;
    
    - Update the french translation;
  
 -- Filippo Rusconi <rusconi-debian@laposte.net>  Tue, 20 Apr 2010 22:37:24 +0200

massxpert (2.1.1-1) unstable; urgency=low

  * Upstream release:
    - Fix programming error: use of an uninitialised variable.
  
  * debian/rules: remove the 'dh_desktop -a' call.

 -- Filippo Rusconi <rusconi-debian@laposte.net>  Wed, 13 Jan 2010 20:49:30 +0100

massxpert (2.1.0-1) unstable; urgency=low

  * Upstream release:
    
    - Show the current selection coordinates in the sequence editor window;
    
    - Fixed nasty bug due to reusing freed memory. Interestingly, that bug
    only showed up on MOSX;
    
    - Code cleanup (amongs which a number of C-style casts were moved to
      C++-reinterpret_cast's;
      
    - Fix memory leaks;
  
    - Fix programming style glitches.

 -- Filippo Rusconi <rusconi-debian@laposte.net>  Tue, 22 Dec 2009 15:44:58 +0100

massxpert (2.0.9-1) unstable; urgency=low

  * Upstream release:
    
    - Fixed a bug causing a crash in corner polymer cleavage cases.

  * Switched to source format 3.0 (quilt);
  
 -- Filippo Rusconi <rusconi-debian@laposte.net>  Thu, 26 Nov 2009 20:51:48 +0100

massxpert (2.0.8-1) unstable; urgency=low

  * New upstream release:
  
    - data : fix dna polymer chemistry definition to include
    phosphorothioates;
  
    - Added feature to regularly recall to the user to cite massXpert in
    the About dialog window;
    
    - data: ix monomer definition for uracile;
    
    - New version of the massxpert.spec taken from Thomas Spura
    <tomspur@fedoraproject.org>
    
    - data: added deuterium to atom definitions;
    
    - Enable installing the plugins in a specific directory (to help with
    distributions willing to put shared binaries in /usr/lib64);
    
    - XpertMiner : fix potentially massive memory leaks. Thanks cppcheck;
  
    - Code documentation and cleanup;
    
    - XpertCalc: formulas that were added to the memory of the calculator
    can now be removed;
    
    - XpertCalc : implemented per polymer chemistry definition handling of
    window geometry settings;
    
    - data: mprove fragmentation definitions for dna;
    
    - Fix bug due to not really checking the formula syntax while it was
    reported as validated;
    
    - Formulas now accept a double-quote-enclosed title and spaces.
    
  * debian/copyright: add blurb about location of the GPL-3 license on
    Debian systems.
  
  
 -- Filippo Rusconi <rusconi-debian@laposte.net>  Sat, 21 Nov 2009 20:04:21 +0100

massxpert (2.0.7-1) unstable; urgency=low

  * New upstream release:
  
  * Fix problem with version numbering in the previous release;
  
  * Fix absence of the corresponding .orig.tar.gz (made erroneously a
    native package).

 -- Filippo Rusconi <rusconi-debian@laposte.net>  Mon, 05 Oct 2009 22:54:42 +0200
 
  

massxpert (2.0.6.-1) unstable; urgency=low
  
  * Upstream release:
  
    - Fixes to nroff formatting of the man pages (thanks to Daniel Leidert
    for suggestions);

    - XpertCalc: added possibility to insert formulas in the formula line
    edit by Ctrl-clicking buttons in the chemical keypad;
  
    - XpertCalc: added possibility to surround formulas with spaces for
    much better readability in case of complex structures. This is
    performed by Shit-Ctrl-cliking on the chemical pad buttons;

    - XpertCalc: automatically seed m/z calculation dialog window with
    masses from the XpertCalc main window;
    
    - XpertEdit: bug fix in the sequence editor's feedback to the user
    upon entering a bad monomer code character. When a new valid character
    is entered this old error message is removed;
  
    - XpertCalc: added lots of useful buttons to the dna chemical pad
    configuration file;
    
    - Added bibliographical reference to the massXpert paper in
    _Bioinformatics_ to the man pages;
    
    - XpertCalc: added possibility to store formula in a drop-down list so
    as to be able to recall them in ulterior calculations;
    
    - XpertCalc: implemented new feature by which it is possible to set a


=== debian/control ===
Source: massxpert
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <rusconi-debian@laposte.net>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7), libqt4-dev (>=4.4.3), cmake (>=2.6.0), texlive-latex-recommended, texlive-fonts-recommended
Standards-Version: 3.8.4
Homepage: http://www.massxpert.org
Vcs-Git: git://git.debian.org/git/debichem/packages/massxpert.git
Vcs-Browser: http://git.debian.org/?p=debichem/packages/massxpert.git

Package: massxpert
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, massxpert-data (>= ${source:Upstream-Version}), massxpert-data (<< ${source:Upstream-Version}A~)
Suggests: massxpert-doc
Replaces: massxpert-bin
Conflicts: massxpert-bin
Description: linear polymer mass spectrometry software
 massXpert is a program to simulate and analyse mass spectrometric
 data obtained on linear (bio-)polymers. It is the successor of GNU
 polyxmass.
 .
 Four modules allow:
  - making brand new polymer chemistry definitions;
  - using the definitions to perform easy calculations in a desktop
    calculator-like manner;
  - performing sophisticated polymer sequence editing and simulations;
  - perform m/z list comparisons;
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches, calculation of the isotopic
 pattern...

Package: massxpert-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: linear polymer mass spectrometry software - arch-indep data
 massXpert is a program to simulate and analyse mass spectrometric
 data obtained on linear (bio-)polymers. It is the successor of GNU
 polyxmass.
 .
 This package contains the architecture-independent data required for
 the proper functioning of massXpert. For example, polymer chemistry
 definition files are in this package.

Package: massxpert-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Linear polymer mass spectrometry software - manual
 massXpert is a program to simulate and analyse mass spectrometric
 data obtained on linear (bio-)polymers. It is the successor of GNU
 polyxmass.
 .
 This package contains the manual in PDF format.

## massxpert 2.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #############################################################
 # Software configuration
 PROJECT (massxpert)
-SET (VERSION "2.3.6")
+SET (VERSION "2.4.0")
 
 IF (APPLE)
   # If Mac OS X, then capitalize the program name.

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -73,6 +73,7 @@
   sequenceEditorGraphicsViewKeyboardHandling.cpp
   sequenceEditorGraphicsViewKeySequenceHandling.cpp
   sequenceEditorWnd.cpp
+  sequenceImportDlg.cpp
   sequencePurificationDlg.cpp
   sequenceSelection.cpp
 )
@@ -131,6 +132,7 @@
   sequenceEditorFindDlg.hpp
   sequenceEditorGraphicsView.hpp
   sequenceEditorWnd.hpp
+  sequenceImportDlg.hpp
   sequencePurificationDlg.hpp
   )
 
@@ -165,6 +167,7 @@
   ui/polymerModificationDlg.ui
   ui/sequenceEditorFindDlg.ui
   ui/sequenceEditorWnd.ui
+  ui/sequenceImportDlg.ui
   ui/sequencePurificationDlg.ui
 )
 
@@ -270,7 +273,7 @@
 
 # Make sure all the symbols from libmasslib.a are in the executable binary!
 IF (APPLE)
-  SET(MASSLIB -Wl,-all_load ${massxpert_BINARY_DIR}/lib/libmasslib.a -Wl,-noall_load)
+  SET(MASSLIB -Wl,-all_load ${massxpert_BINARY_DIR}/lib/libmasslib.a -Wl,-noall_load -Wl,-framework,CoreFoundation)
 ELSE (APPLE)
   SET(MASSLIB -Wl,-whole-archive ${massxpert_BINARY_DIR}/lib/libmasslib.a -Wl,-no-whole-archive)
 ENDIF (APPLE)
@@ -283,11 +286,6 @@
   ${MASSLIB}
   )
 
-SET (massxpert_TRANSLATIONS massxpert_fr.qm)
-
-INSTALL (FILES ${massxpert_TRANSLATIONS} 
-  DESTINATION ${MASSXPERT_LOCALE_DIR})
-
 IF (APPLE)
   # Copy the massXpert.icns icon file in the bundle
   INSTALL (FILES images/massXpert.icns

=== debian/changelog ===
massxpert (2.4.0-1ubuntu1) natty; urgency=low

  * fix-ftbfs-gcc4.5.patch: fix FTBFS with gcc4.5 because of invalid conversion
    (LP: #756209). Patch retroported from 2.4.1.

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Sun, 24 Apr 2011 12:20:55 +0200

massxpert (2.4.0-1) unstable; urgency=low

  * Upstream release:
  
    - Monoisotopic mass is now the mass of the isotope of highest
    abundance and not of lowest mass. This won't change anything for
    biopolymers, as all the chemical elements used there have their
    lightest isotope of highest abundance;

    - Update the french translation;
    
    - Add two peptide example files.
  
 -- Filippo Rusconi <rusconi-debian@laposte.net>  Fri, 10 Dec 2010 11:16:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: massxpert
 Section: science
 Priority: optional
-Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
 Uploaders: Filippo Rusconi <rusconi-debian@laposte.net>
 DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 7), libqt4-dev (>=4.4.3), cmake (>=2.6.0), texlive-latex-recommended, texlive-fonts-recommended

## massxpert 3.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #############################################################
 # Software configuration
 PROJECT (massxpert)
-SET (VERSION "2.4.0")
+SET (VERSION "3.0.0")
 
 IF (APPLE)
   # If Mac OS X, then capitalize the program name.
@@ -122,6 +122,10 @@
 
 IF (${BUILD_PROGRAM})
 
+  IF (CMAKE_BUILD_TYPE STREQUAL "debug")
+    ADD_DEFINITIONS (-g -O2)
+  ENDIF ()
+  
   ################
   # Search for Qt4
   SET (QT_USE_QTXML TRUE)

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -13,11 +13,10 @@
   calculatorWnd.cpp
   chemPadButton.cpp
   cleavageDlg.cpp
-  cleaveOligomerTreeView.cpp
-  cleaveOligomerTreeViewItem.cpp
-  cleaveOligomerTreeViewMimeData.cpp
-  cleaveOligomerTreeViewModel.cpp
-  cleaveOligomerTreeViewSortProxyModel.cpp
+  cleaveOligomerTableView.cpp
+  cleaveOligomerTableViewMimeData.cpp
+  cleaveOligomerTableViewModel.cpp
+  cleaveOligomerTableViewSortProxyModel.cpp
   cleaveSpecDefDlg.cpp
   compositionsDlg.cpp
   compositionTreeView.cpp
@@ -28,21 +27,19 @@
   crossLinkerDefDlg.cpp
   decimalPlacesOptionsDlg.cpp
   fragmentationDlg.cpp
-  fragmentOligomerTreeView.cpp
-  fragmentOligomerTreeViewItem.cpp
-  fragmentOligomerTreeViewMimeData.cpp
-  fragmentOligomerTreeViewModel.cpp
-  fragmentOligomerTreeViewSortProxyModel.cpp
+  fragmentOligomerTableView.cpp
+  fragmentOligomerTableViewMimeData.cpp
+  fragmentOligomerTableViewModel.cpp
+  fragmentOligomerTableViewSortProxyModel.cpp
   fragSpecDefDlg.cpp
   isotopicPatternCalculationDlg.cpp
   main.cpp
   mainWindow.cpp
   massSearchDlg.cpp
-  massSearchOligomerTreeView.cpp
-  massSearchOligomerTreeViewItem.cpp
-  massSearchOligomerTreeViewMimeData.cpp 
-  massSearchOligomerTreeViewModel.cpp
-  massSearchOligomerTreeViewSortProxyModel.cpp
+  massSearchOligomerTableView.cpp
+  massSearchOligomerTableViewMimeData.cpp 
+  massSearchOligomerTableViewModel.cpp
+  massSearchOligomerTableViewSortProxyModel.cpp
   modifDefDlg.cpp
   monomerCodeEvaluator.cpp
   monomerCrossLinkDlg.cpp
@@ -53,16 +50,14 @@
   mzCalculationTreeViewItem.cpp
   mzCalculationTreeViewModel.cpp
   mzCalculationTreeViewSortProxyModel.cpp
-  mzLabInputOligomerTreeView.cpp
-  mzLabInputOligomerTreeViewDlg.cpp
-  mzLabInputOligomerTreeViewItem.cpp
-  mzLabInputOligomerTreeViewModel.cpp
-  mzLabInputOligomerTreeViewSortProxyModel.cpp
-  mzLabOutputOligomerTreeView.cpp
-  mzLabOutputOligomerTreeViewDlg.cpp
-  mzLabOutputOligomerTreeViewItem.cpp
-  mzLabOutputOligomerTreeViewModel.cpp
-  mzLabOutputOligomerTreeViewSortProxyModel.cpp
+  mzLabInputOligomerTableView.cpp
+  mzLabInputOligomerTableViewDlg.cpp
+  mzLabInputOligomerTableViewModel.cpp
+  mzLabInputOligomerTableViewSortProxyModel.cpp
+  mzLabOutputOligomerTableView.cpp
+  mzLabOutputOligomerTableViewDlg.cpp
+  mzLabOutputOligomerTableViewModel.cpp
+  mzLabOutputOligomerTableViewSortProxyModel.cpp
   mzLabWnd.cpp
   pkaPhPiDlg.cpp
   polChemDefWnd.cpp
@@ -90,9 +85,9 @@
   calculatorWnd.hpp
   chemPadButton.hpp
   cleavageDlg.hpp
-  cleaveOligomerTreeView.hpp
-  cleaveOligomerTreeViewMimeData.hpp
-  cleaveOligomerTreeViewModel.hpp
+  cleaveOligomerTableView.hpp
+  cleaveOligomerTableViewMimeData.hpp
+  cleaveOligomerTableViewModel.hpp
   cleaveSpecDefDlg.hpp
   compositionsDlg.hpp
   compositionTreeView.hpp
@@ -101,16 +96,16 @@
   crossLinkerDefDlg.hpp
   decimalPlacesOptionsDlg.hpp
   fragmentationDlg.hpp
-  fragmentOligomerTreeView.hpp
-  fragmentOligomerTreeViewMimeData.hpp
-  fragmentOligomerTreeViewModel.hpp
+  fragmentOligomerTableView.hpp
+  fragmentOligomerTableViewMimeData.hpp
+  fragmentOligomerTableViewModel.hpp
   fragSpecDefDlg.hpp
   isotopicPatternCalculationDlg.hpp
   mainWindow.hpp
   massSearchDlg.hpp
-  massSearchOligomerTreeView.hpp
-  massSearchOligomerTreeViewMimeData.hpp
-  massSearchOligomerTreeViewModel.hpp
+  massSearchOligomerTableView.hpp
+  massSearchOligomerTableViewMimeData.hpp
+  massSearchOligomerTableViewModel.hpp
   modifDefDlg.hpp
   monomerCodeEvaluator.hpp
   monomerCrossLinkDlg.hpp
@@ -119,12 +114,12 @@
   mzCalculationDlg.hpp
   mzCalculationTreeView.hpp
   mzCalculationTreeViewModel.hpp
-  mzLabInputOligomerTreeView.hpp
-  mzLabInputOligomerTreeViewDlg.hpp
-  mzLabInputOligomerTreeViewModel.hpp
-  mzLabOutputOligomerTreeView.hpp
-  mzLabOutputOligomerTreeViewDlg.hpp
-  mzLabOutputOligomerTreeViewModel.hpp
+  mzLabInputOligomerTableView.hpp
+  mzLabInputOligomerTableViewDlg.hpp
+  mzLabInputOligomerTableViewModel.hpp
+  mzLabOutputOligomerTableView.hpp
+  mzLabOutputOligomerTableViewDlg.hpp
+  mzLabOutputOligomerTableViewModel.hpp
   mzLabWnd.hpp
   pkaPhPiDlg.hpp
   polChemDefWnd.hpp
@@ -159,8 +154,8 @@
   ui/monomerDefDlg.ui
   ui/monomerModificationDlg.ui
   ui/mzCalculationDlg.ui
-  ui/mzLabInputOligomerTreeViewDlg.ui
-  ui/mzLabOutputOligomerTreeViewDlg.ui
+  ui/mzLabInputOligomerTableViewDlg.ui
+  ui/mzLabOutputOligomerTableViewDlg.ui
   ui/mzLabWnd.ui
   ui/pkaPhPiDlg.ui
   ui/polChemDefWnd.ui
@@ -204,6 +199,10 @@
 ########################################################
 # Build
 
+IF (CMAKE_BUILD_TYPE STREQUAL "debug")
+  ADD_DEFINITIONS (-g -O0)
+ENDIF ()
+
 QT4_WRAP_CPP (massxpert_MOC_SRCS  ${massxpert_MOC_HDRS})
 
 QT4_WRAP_UI (massxpert_UIS_H ${massxpert_UIS})
@@ -280,10 +279,10 @@
 
   
 TARGET_LINK_LIBRARIES (${PROGNAME}
+  ${MASSLIB}
   ${QT_LIBRARIES}
   ${QT_QTXML_LIBRARIES}
   ${QT_QTSVG_LIBRARIES}
-  ${MASSLIB}
   )
 
 IF (APPLE)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,8 @@
   ionizable.cpp
   ionizeRule.cpp
   isotope.cpp
+  isotopicCurve.cpp
+  isotopicPatternCalculator.cpp
   isotopicPeak.cpp
   massList.cpp
   modif.cpp
@@ -63,6 +65,7 @@
   chemEntVignette.hpp
   chemEntVignetteRenderer.hpp
   crossLinkList.hpp
+  isotopicPatternCalculator.hpp
   oligomerList.hpp
   polymer.hpp
   )
@@ -70,6 +73,10 @@
 
 ########################################################
 # Build
+
+IF (CMAKE_BUILD_TYPE STREQUAL "debug")
+  ADD_DEFINITIONS (-g -O0)
+ENDIF ()
 
 QT4_WRAP_CPP (masslib_MOC_SRCS  ${masslib_MOC_HDRS})
